// ---------------------------------------------------------------------------
//          .
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Green
#property indicator_minimum 0

//    .
extern int LENGTH         = 1;
//  .
extern int AVERAGE_PERIOD = 20;

//  .
double buf_av[], buf_m[];
//   .
int work_period1, work_period2;

// .
int init() {
  IndicatorShortName(StringConcatenate(
    "AZZX - PERCENT CHANGE v1.0 (", LENGTH, ", ", AVERAGE_PERIOD, ")"));
  IndicatorDigits(1);
  IndicatorBuffers(2);
  
  SetIndexBuffer(0, buf_av);
  SetIndexBuffer(1, buf_m);
  
  SetIndexEmptyValue(0, -1);
  SetIndexLabel(0, "PERCENT CHANGE");
  
  work_period1 = Bars - LENGTH;
  work_period2 = work_period1 - AVERAGE_PERIOD;
  
  return(0);
}

//  .
int start() {
  for(int i = Bars - IndicatorCounted() - 1; i >= 0; i--) {
    if(i < work_period1) {
      buf_m[i] = MathAbs(Close[i] - Close[i + LENGTH]) / Close[i + LENGTH] * 100;
    }
    
    if(i < work_period2) {
      double s = 0;
    
      for(int j = i + AVERAGE_PERIOD - 1; j >= i; j--) {
        s += buf_m[j];
      }
      
      buf_av[i] = s / AVERAGE_PERIOD;
    } else {
      buf_av[i] = -1;
    }
  }

  return(0);
}

